//-----------------------------------------------------------------------------
// File: BasicHLSL.fx
//
// Desc: BasicHLSL Tvp̃GtFNg t@C
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// O[o ϐ
//-----------------------------------------------------------------------------
float4 g_MaterialAmbientColor;	// }eÃArGgF
float4 g_MaterialDiffuseColor;	// }eÃfBt[YF

// ̃GtFNg t@C͒P̕sgp
float3 g_LightDir = normalize(float3(1.0f, 1.0f, 1.0f));	// [hԂł̌̕
float4 g_LightAmbient = { 1.0f, 1.0f, 1.0f, 1.0f };			// Cg̃ArGgF
float4 g_LightDiffuse = { 1.0f, 1.0f, 1.0f, 1.0f };			// Cg̃fBt[YF

texture g_RenderTargetTexture;	// tXN[ _[ ^[Qbg eNX`
texture g_MeshTexture;			// bVp̃J[ eNX`

float	 g_fTime;					// bPʂ̃AvP[V
float4x4 g_mWorld;					// IuWFNgp̃[hs
float4x4 g_mWorldViewProjection;	// [h * r[ * ˉes



//-----------------------------------------------------------------------------
// eNX` Tv
//-----------------------------------------------------------------------------
sampler RenderTargetSampler = 
sampler_state
{
    Texture = <g_RenderTargetTexture>;
    MinFilter = POINT;  
    MagFilter = POINT;
    MipFilter = NONE;
    AddressU = Clamp;
    AddressV = Clamp;
};

sampler MeshTextureSampler = 
sampler_state
{
    Texture = <g_MeshTexture>;    
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};


//-----------------------------------------------------------------------------
// _VF[_o͍\
//-----------------------------------------------------------------------------
struct VS_OUTPUT
{
    float4 Position   : POSITION;   // _̈ʒu
    float4 Diffuse    : COLOR0;     // _̃fBt[YF
    float2 TextureUV  : TEXCOORD0;  // _̃eNX`W
};


//-----------------------------------------------------------------------------
// Name: RenderSceneVS
// Type: _VF[_                                      
// Desc: ̃VF[_͕WIȍWϊƏƖvZ܂B
//-----------------------------------------------------------------------------
VS_OUTPUT RenderSceneVS( float4 vPos : POSITION, 
                         float3 vNormal : NORMAL,
                         float2 vTexCoord0 : TEXCOORD0 )
{
    VS_OUTPUT Output;
    float3 vNormalWorldSpace;
  
	// ɒ_̃IuWFNgԂł̈ʒuAj[V܂
    float4 vAnimatedPos = vPos + float4( sin(g_fTime) * vPos.x/2, 0, 0, 0 );
    
    // IuWFNgԂ瓯ˉeԂɃIuWFNgWϊ
    Output.Position = mul(vAnimatedPos, g_mWorldViewProjection);
    
    // IuWFNgԂ烏[hԂɖ@Wϊ
    vNormalWorldSpace = normalize(mul(vNormal, (float3x3)g_mWorld)); // normal (world space)
    
    // Pȕs̎vZ
    Output.Diffuse.rgb = g_MaterialDiffuseColor * g_LightDiffuse * max(0,dot(vNormalWorldSpace, g_LightDir)) + 
                         g_MaterialAmbientColor * g_LightAmbient;   
    Output.Diffuse.a = 1.0f; 
    
    // eNX`W̓Rs[邾
    Output.TextureUV = vTexCoord0; 
    
    return Output;    
}


//-----------------------------------------------------------------------------
// sNZ VF[_o͍\
//-----------------------------------------------------------------------------
struct PS_OUTPUT
{
    float4 RGBColor : COLOR0;  // sNZFr    
};


//-----------------------------------------------------------------------------
// Name: RenderScenePS                                        
// Type: sNZ VF[_
// Desc: ̃VF[_́AeNX`FƃfBt[Y }eAF
//       W[găsNZ̐Fo͂܂B
//-----------------------------------------------------------------------------
PS_OUTPUT RenderScenePS( VS_OUTPUT In ) 
{ 
    PS_OUTPUT Output;

    // bV eNX`QƂAfBt[YƃW[g
    Output.RGBColor = tex2D(MeshTextureSampler, In.TextureUV) * In.Diffuse;

    return Output;
}



//-----------------------------------------------------------------------------
// Name: RenderScene
// Type: eNjbN                                    
// Desc: _[^[QbgɃV[_O
//-----------------------------------------------------------------------------
technique RenderScene
{
    pass P0
    {          
        VertexShader = compile vs_1_1 RenderSceneVS();
        PixelShader  = compile ps_1_1 RenderScenePS(); // PȃsNZ VF[_(KvɉČŒ@\ɂύXł܂)
    }
}
